Index: build/boot/x86/text.cfg
===================================================================
--- build/boot/x86/text.cfg	(revision 56632)
+++ build/boot/x86/text.cfg	(working copy)
@@ -1,5 +1,11 @@
 default install
+ 
 label install
+	# Detect the cpu, jump to the appropriate label
+	kernel ifcpu64.c32
+	append amd64-install -- i386-install
+ 
+label i386-install
 	menu label ^Install
 	menu default
 	kernel ${KERNEL}
Index: build/boot/x86/gtk.cfg
===================================================================
--- build/boot/x86/gtk.cfg	(revision 56632)
+++ build/boot/x86/gtk.cfg	(working copy)
@@ -1,4 +1,9 @@
 label installgui
+	# Detect the cpu, jump to the appropriate label
+	kernel ifcpu64.c32
+	append amd64-installgui -- i386-installgui
+ 
+label i386-installgui
 	menu label ^Graphical install
 	kernel ${KERNEL}
 	append ${VIDEO_MODE_GTK} initrd=${INITRD_GTK} -- quiet ${CONSOLE}
Index: build/boot/x86/adtext.cfg
===================================================================
--- build/boot/x86/adtext.cfg	(revision 56632)
+++ build/boot/x86/adtext.cfg	(working copy)
@@ -1,12 +1,26 @@
 label expert
+	# Detect the cpu, jump to the appropriate label
+	kernel ifcpu64.c32
+	append amd64-expert -- i386-expert
+label i386-expert
 	menu label ^Expert install
 	kernel ${KERNEL}
 	append priority=low ${VIDEO_MODE} initrd=${INITRD} -- ${CONSOLE}
+
 label rescue
+	# Detect the cpu, jump to the appropriate label
+	kernel ifcpu64.c32
+	append amd64-rescue -- i386-rescue
+label i386-rescue
 	menu label ^Rescue mode
 	kernel ${KERNEL}
 	append ${VIDEO_MODE} initrd=${INITRD} rescue/enable=true -- quiet ${CONSOLE}
+
 label auto
+	# Detect the cpu, jump to the appropriate label
+	kernel ifcpu64.c32
+	append amd64-auto -- i386-auto
+label i386-auto
 	menu label ^Automated install
 	kernel ${KERNEL}
 	append auto=true priority=critical ${VIDEO_MODE} initrd=${INITRD} -- quiet ${CONSOLE}
Index: build/boot/x86/adgtk.cfg
===================================================================
--- build/boot/x86/adgtk.cfg	(revision 56632)
+++ build/boot/x86/adgtk.cfg	(working copy)
@@ -2,14 +2,27 @@
 menu width 58
 
 label expertgui
+	# Detect the cpu, jump to the appropriate label
+	kernel ifcpu64.c32
+	append amd64-expertgui -- i386-expertgui
+label i386-expertgui
 	menu label Graphical expert install
 	kernel ${KERNEL}
 	append priority=low ${VIDEO_MODE_GTK} initrd=${INITRD_GTK} -- ${CONSOLE}
+
 label rescuegui
+	# Detect the cpu, jump to the appropriate label
+	kernel ifcpu64.c32
+	append amd64-rescuegui -- i386-rescuegui
+label i386-rescuegui
 	menu label Graphical rescue mode
 	kernel ${KERNEL}
 	append ${VIDEO_MODE_GTK} initrd=${INITRD_GTK} rescue/enable=true -- quiet ${CONSOLE} 
 label autogui
+	# Detect the cpu, jump to the appropriate label
+	kernel ifcpu64.c32
+	append amd64-autogui -- i386-autogui
+label i386-autogui
 	menu label Graphical automated install
 	kernel ${KERNEL}
 	append auto=true priority=critical ${VIDEO_MODE_GTK} initrd=${INITRD_GTK} -- quiet ${CONSOLE}
Index: build/boot/x86/amdtext.cfg
===================================================================
--- build/boot/x86/amdtext.cfg	(revision 56632)
+++ build/boot/x86/amdtext.cfg	(working copy)
@@ -1,4 +1,3 @@
-default64 amd64-install
 label amd64-install
 	menu label ^64 bit install
 	menu default64
Index: build/config/x86.cfg
===================================================================
--- build/config/x86.cfg	(revision 56632)
+++ build/config/x86.cfg	(working copy)
@@ -90,6 +90,7 @@
 	
 	if [ ! "$(NO_VESAMENU)" ]; then \
 		mcopy -i$(TEMP_BOOT) /usr/lib/syslinux/vesamenu.c32 ::vesamenu.c32; \
+		mcopy -i$(TEMP_BOOT) /usr/lib/syslinux/ifcpu64.c32 ::ifcpu64.c32; \
 		if [ -e $(TEMP_BOOT_SCREENS)/splash.png ]; then \
 			mcopy -i$(TEMP_BOOT) $(TEMP_BOOT_SCREENS)/splash.png ::splash.png; \
 		fi; \
